define(['require', 'https://d3js.org/d3.v5.min.js'], function (requirejs, d3) { 'use strict';

  function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new TypeError("Cannot call a class as a function");
    }
  }

  function _defineProperties(target, props) {
    for (var i = 0; i < props.length; i++) {
      var descriptor = props[i];
      descriptor.enumerable = descriptor.enumerable || false;
      descriptor.configurable = true;
      if ("value" in descriptor) descriptor.writable = true;
      Object.defineProperty(target, descriptor.key, descriptor);
    }
  }

  function _createClass(Constructor, protoProps, staticProps) {
    if (protoProps) _defineProperties(Constructor.prototype, protoProps);
    if (staticProps) _defineProperties(Constructor, staticProps);
    return Constructor;
  }

  function _inherits(subClass, superClass) {
    if (typeof superClass !== "function" && superClass !== null) {
      throw new TypeError("Super expression must either be null or a function");
    }

    subClass.prototype = Object.create(superClass && superClass.prototype, {
      constructor: {
        value: subClass,
        writable: true,
        configurable: true
      }
    });
    if (superClass) _setPrototypeOf(subClass, superClass);
  }

  function _getPrototypeOf(o) {
    _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {
      return o.__proto__ || Object.getPrototypeOf(o);
    };
    return _getPrototypeOf(o);
  }

  function _setPrototypeOf(o, p) {
    _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {
      o.__proto__ = p;
      return o;
    };

    return _setPrototypeOf(o, p);
  }

  function _isNativeReflectConstruct() {
    if (typeof Reflect === "undefined" || !Reflect.construct) return false;
    if (Reflect.construct.sham) return false;
    if (typeof Proxy === "function") return true;

    try {
      Date.prototype.toString.call(Reflect.construct(Date, [], function () {}));
      return true;
    } catch (e) {
      return false;
    }
  }

  function _assertThisInitialized(self) {
    if (self === void 0) {
      throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
    }

    return self;
  }

  function _possibleConstructorReturn(self, call) {
    if (call && (typeof call === "object" || typeof call === "function")) {
      return call;
    }

    return _assertThisInitialized(self);
  }

  function _createSuper(Derived) {
    var hasNativeReflectConstruct = _isNativeReflectConstruct();

    return function _createSuperInternal() {
      var Super = _getPrototypeOf(Derived),
          result;

      if (hasNativeReflectConstruct) {
        var NewTarget = _getPrototypeOf(this).constructor;

        result = Reflect.construct(Super, arguments, NewTarget);
      } else {
        result = Super.apply(this, arguments);
      }

      return _possibleConstructorReturn(this, result);
    };
  }

  function _toConsumableArray(arr) {
    return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread();
  }

  function _arrayWithoutHoles(arr) {
    if (Array.isArray(arr)) return _arrayLikeToArray(arr);
  }

  function _iterableToArray(iter) {
    if (typeof Symbol !== "undefined" && Symbol.iterator in Object(iter)) return Array.from(iter);
  }

  function _unsupportedIterableToArray(o, minLen) {
    if (!o) return;
    if (typeof o === "string") return _arrayLikeToArray(o, minLen);
    var n = Object.prototype.toString.call(o).slice(8, -1);
    if (n === "Object" && o.constructor) n = o.constructor.name;
    if (n === "Map" || n === "Set") return Array.from(o);
    if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen);
  }

  function _arrayLikeToArray(arr, len) {
    if (len == null || len > arr.length) len = arr.length;

    for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i];

    return arr2;
  }

  function _nonIterableSpread() {
    throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
  }

  var e=function(){function t(t,e){this.name=t,this.slot=e||null,this.attributes=new Map;}return t.prototype.getName=function(){return this.name},t.prototype.getSlot=function(){return this.slot},t.prototype.getAttributes=function(){return this.attributes},t.slotLimit=function(e,n){return new t("limit",e).attr("n",n)},t.dataLimit=function(e){return new t("limit").attr("n",e)},t.prototype.attr=function(t,e){return this.attributes.set(t,e),this},t}(),n=function(t,e){return (n=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(t,e){t.__proto__=e;}||function(t,e){for(var n in e)e.hasOwnProperty(n)&&(t[n]=e[n]);})(t,e)};
  /*! *****************************************************************************
  Copyright (c) Microsoft Corporation. All rights reserved.
  Licensed under the Apache License, Version 2.0 (the "License"); you may not use
  this file except in compliance with the License. You may obtain a copy of the
  License at http://www.apache.org/licenses/LICENSE-2.0

  THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
  KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
  WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
  MERCHANTABLITY OR NON-INFRINGEMENT.

  See the Apache Version 2.0 License for specific language governing permissions
  and limitations under the License.
  ***************************************************************************** */function r(t,e){function r(){this.constructor=t;}n(t,e),t.prototype=null===e?Object.create(e):(r.prototype=e.prototype,new r);}function o(t,e,n){return t.getDecoration(e,n)}function i(t){return t.hasDecoration("hasSelection")?o(t,"hasSelection",!1):!!function(t){return "getSlot"in t&&"hasDecorationOnDataPoints"in t}(t)&&t.hasDecorationOnDataPoints("selected")}var u,s=function(){function t(t,e){this.min=t,this.max=e;}return t.prototype.asArray=function(){return [this.min,this.max]},t.empty=new t(0,0),t}(),a=function(t){function e(e,n){return t.call(this,e,n)||this}return r(e,t),e.fromRS=function(t){return new s(t.min,t.max)},e}(s),l=function(){function t(t,e){this.source=t,this.index=e,this.key=t.getKey(!1),this.caption=t.getCaption("label")||"";var n=t.getItems()||[];this.segments=n.map((function(t){return new p(t)}));}return Object.defineProperty(t.prototype,"selected",{get:function(){return o(this.source,"selected",!1)},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"highlighted",{get:function(){return o(this.source,"highlighted",!1)},enumerable:!0,configurable:!0}),t}(),c=function(t){function e(e,n){return t.call(this,e,n)||this}return r(e,t),e}(l),h=function(){function t(t){this.source=t,this.key=this.source.getUniqueName()||"",this.caption=this.source.getCaption("label")||"";}return Object.defineProperty(t.prototype,"selected",{get:function(){return o(this.source,"selected",!1)},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"highlighted",{get:function(){return o(this.source,"highlighted",!1)},enumerable:!0,configurable:!0}),t}(),p=function(t){function e(e){return t.call(this,e)||this}return r(e,t),e}(h),f=new(function(){function t(){}return t.prototype.format=function(t){return t?t.toString():""},t}());!function(t){t.label="label",t.data="data";}(u||(u={}));var g=function(){function t(t,e,n,r,o){this.source=t,this.tuples=e,this.segments=n,this.domain=r,this.caption=o;var i=t.dataItems||[],u=i.length>0?i[0]:null,s=u&&u.asCont();s?(this._labelFormatter=s.getFormatter("label")||f,this._dataFormatter=s.getFormatter("data")||f):this._labelFormatter=this._dataFormatter=f;}return Object.defineProperty(t.prototype,"mapped",{get:function(){return this.source.mapped},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"dataType",{get:function(){var t=this.source.getDataItem(0);return this.mapped&&t?t.type:"none"},enumerable:!0,configurable:!0}),t.prototype.format=function(t,e){return function(t,e){return t.format(e)}(e===u.data?this._dataFormatter:this._labelFormatter,t)},t}(),d=function(t){function e(e,n,r,o,i){return t.call(this,e,n,r,o,i)||this}return r(e,t),e}(g),m=function(){function t(t,e){this.source=t,this.key=t.getKey(!1),this.dataSet=e;}return Object.defineProperty(t.prototype,"selected",{get:function(){return o(this.source,"selected",!1)},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"highlighted",{get:function(){return o(this.source,"highlighted",!1)},enumerable:!0,configurable:!0}),t.prototype.tuple=function(t){var e=this._getSlot(t);if(!e||0===e.tuples.length)return null;var n=this.source.get(e.source);if(!n)return null;var r=n.asCat();return r?e.tuples[r.index]:null},t.prototype.value=function(t){var e=this._getSlot(t),n=e&&this.source.get(e.source);if(!n)return null;var r=n.asCont();return r&&"numeric"===r.valueType?r.value:null},t.prototype.caption=function(t){var e=this._getSlot(t),n=e&&this.source.get(e.source);return n&&n.getCaption("data")||""},t.prototype._getSlot=function(t){return "string"==typeof t?this.dataSet.slotMap.get(t)||null:this.dataSet.cols[t]||null},t}(),y=function(t){function e(e,n){return t.call(this,e,n)||this}return r(e,t),e}(m),v=function(){function t(t,e,n){var r=this;this.source=t,this.rows=t.dataPoints.map((function(t){return new y(t,r)})),this.cols=e,this.slotMap=n;}return t.filterRows=function(t,e,n){return t.filter((function(t){var r=t.tuple(e);return !!r&&r.key===n}))},Object.defineProperty(t.prototype,"hasSelections",{get:function(){return i(this.source)},enumerable:!0,configurable:!0}),t}(),_=function(t){function e(e,n,r){return t.call(this,e,n,r)||this}return r(e,t),e}(v);function b(t){var e=new Map,n=t.getSlots().map((function(t,n){var r=[],o=[],i=s.empty,u="";if(t.isMapped()){var l=t.getDataItem(0);if(u=l.getCaption("label"),"cat"===l.getRSType())r=l.getTuples().map((function(t,e){return new c(t,e)})),o=l.getItemClassSet(0).getItemClasses().map((function(t){return new p(t)}));else i=a.fromRS(l.getDomain()),o.push(new p(l.getItemClass()));}var h=new d(t,r,o,i,u);return e.set(t.name,h),h}));return new _(t,n,e)}function w(t){return t<0?0:t>255?255:Math.floor(t)}var C=function(){function t(t,e,n,r){var o;this.r=w(t),this.g=w(e),this.b=w(n),this.a=(o=r)<0?0:o>1?1:o;}return t.fromObject=function(e){return new t(e.r,e.g,e.b,void 0===e.a?1:e.a)},t.prototype.toString=function(){return 1===this.a?"rgb("+this.r+","+this.g+","+this.b+")":"rgba("+this.r+","+this.g+","+this.b+","+this.a+")"},t}();function S(t,e){var n=null;if(t instanceof m)n=t.source.getDataSet(e);else{var r=t.source.getDataItem(e);n=r&&r.getDataSet(e);}return !!n&&i(n)}var P=function(t){return "rgba("+t.r+","+t.g+","+t.b+",0.4)"},j=function(t){return "rgba("+Math.round(.7*t.r)+","+Math.round(.7*t.g)+","+Math.round(.7*t.b)+","+t.a+")"},x=function(){function t(t,e,n){this.source=t,this._dataContext=e,this._slotResolver=n;}return Object.defineProperty(t.prototype,"slot",{get:function(){return this.source.slot},enumerable:!0,configurable:!0}),t.prototype.getColor=function(t){return t?C.fromObject(this.source.getTupleColor(t.source,-1)):C.fromObject(this.source.getColor(null))},t.prototype._getTuple=function(t){if(t instanceof l)return t;var e=this.slot||this._slotResolver(t.dataSet,this.source.name);return e?t.tuple(e):null},t.prototype.getFillColor=function(t){if(null===t)return this.source.getColor(null).toString();var e,n=this._getTuple(t);return e=n?this.source.getTupleColor(n.source,-1):this.source.getColor(t.source),!t.selected&&S(t,this._dataContext)?P(e):e.toString()},t.prototype.getOutlineColor=function(t){if(null===t)return this.source.getColor(null).toString();var e,n=this._getTuple(t);return e=n?this.source.getTupleColor(n.source,-1):this.source.getColor(t.source),t.highlighted||t.selected&&S(t,this._dataContext)?j(e):null},t}(),O=function(t,e,n){this.color=t,this.at=e,this.value=n;};function I(t){return t.map((function(t){return new O(C.fromObject(t.color),t.at,t.value)}))}var D=function(){function t(t,e,n){this.source=t,this._slot=e,this._dataContext=n,this.stops=I(t.stops),this.aligned=I(t.aligned),this.interpolate=t.interpolate;}return t.prototype.getColor=function(t){return C.fromObject(this.source.getColor(t))},t.prototype.getFillColor=function(t){var e=this._slot?Number(t.value(this._slot)):0,n=this.source.getColor(e);return !t.selected&&S(t,this._dataContext)?P(n):n.toString()},t.prototype.getOutlineColor=function(t){var e=this._slot?Number(t.value(this._slot)):0,n=this.source.getColor(e);return t.highlighted||t.selected&&S(t,this._dataContext)?j(n):null},t}(),E=function(){function t(t,e,n){this.source=t,this._dataContext=e,this._lastDataItem=null,this._cachedStops=null,this._slotResolver=n;}return Object.defineProperty(t.prototype,"slot",{get:function(){return this.source.slot},enumerable:!0,configurable:!0}),t.prototype.getColorStops=function(t){var e=t?t.source.getDataItem(0):null,n=e&&e.asCont(),r=n?n.getDomain(null):null,o=this.source.getColorStops(n,r),i=t?t.source.name:null;return new D(o,i,this._dataContext)},t.prototype._fetchColorStops=function(t){var e=t.source.getDataSet(this._dataContext),n=this.slot||this._slotResolver(t.dataSet,this.source.name),r=n?e.getSlot(n):null,o=r?r.getDataItem(0):null,i=o?o.asCont():null;if(this.source.dirty||!this._cachedStops||i!==this._lastDataItem){var u=i?i.getDomain(null):null,s=this.source.getColorStops(i,u);this._cachedStops=new D(s,r&&r.name,this._dataContext),this._lastDataItem=i;}return this._cachedStops},t.prototype.getFillColor=function(t){return this._fetchColorStops(t).getFillColor(t)},t.prototype.getOutlineColor=function(t){return this._fetchColorStops(t).getOutlineColor(t)},t}(),T=function(t){function e(e){var n=t.call(this,e.r,e.g,e.b,e.a)||this;return n._color=e,n}return r(e,t),e.prototype.getRed=function(){return this.r},e.prototype.getGreen=function(){return this.g},e.prototype.getBlue=function(){return this.b},e.prototype.getAlpha=function(){return this.a},e}(C),R=Object.freeze({min:0,max:0,empty:!0,explicit:!1,getMin:function(){return 0},getMax:function(){return 0},isEmpty:function(){return !0},isExplicit:function(){return !1}}),F=function(){function t(t,e,n,r,o,i){this.caption=t,this.color=e,this.shape=n,this.selected=r,this.highlighted=o,this.ref=i;}return t.prototype.getCaption=function(){return this.caption},t.prototype.getColor=function(){return this.color?new T(this.color):null},t.prototype.getShape=function(){return this.shape},t.prototype.isSelected=function(){return this.selected},t.prototype.isHighlighted=function(){return this.highlighted},t.prototype.getRef=function(){return this.ref},t}(),M=function(){function t(t,e,n,r,o,i){this.type=t,this.channel=e,this.slot=n,this.caption=r,this.subCaption=o,this.ref=i;}return t.prototype.getRSType=function(){return this.type},t.prototype.getChannel=function(){return this.channel},t.prototype.getSlot=function(){return this.slot},t.prototype.getCaption=function(){return this.caption},t.prototype.getSubCaption=function(){return this.subCaption},t.prototype.getRef=function(){return this.ref},t}(),L=function(t){function e(e,n,r,i,u){var s=this,a=n&&n.source,l=a&&a.name,c=a&&a.getDataItem(0),h=c&&c.asCat();s=t.call(this,"cat",e,l,r,"",h)||this;var p=h?h.tuples:[];return s.entries=p.map((function(t){var e=t.getCaption("label")||"",n=u&&u.source.getTupleColor(t,-1),r=o(t,"selected",!1),s=o(t,"highlighted",!1);return new F(e,n?C.fromObject(n):null,i,r,s,t)})),s}return r(e,t),e.prototype.getEntries=function(){return this.entries},e}(M),A=function(t){function e(e,n,r,o){var i=this,u=n&&n.source,s=u&&u.name,a=u&&u.getDataItem(0),l=a&&a.asCont();if((i=t.call(this,"cont",e,s,r,"",l)||this).domain=l?l.getDomain(null):R,o&&"color"===e){var c=o.source.getColorStops(l,null);i.stops=c.stops,i.interpolate=c.interpolate;}else i.stops=null,i.interpolate=!1;return i}return r(e,t),e.prototype.getDomain=function(){return this.domain},e.prototype.getInterpolate=function(){return this.interpolate},e.prototype.getStops=function(){return this.stops},e}(M);function z(t,e,n,r){if(!t)return [];var o=new Map,i=new Map;e.palettes.forEach((function(e){var n=e.slot||r&&r(t,e.source.name);n&&(e instanceof x?o.set(n,e):e instanceof E&&i.set(n,e));}));var u=[];return t.cols.forEach((function(t){var e=t.source;if(e.mapped){var r=e.getDataItem(0);if(r)switch(r.type){case"cat":if(-1===e.channels.indexOf("color"))return;var s=o.get(e.name);s&&u.push(new L("color",t,t.caption,n.legendShape,s));break;case"cont":if(-1!==e.channels.indexOf("color")){var a=i.get(e.name);a&&u.push(new A("color",t,t.caption,a));}-1!==e.channels.indexOf("size")&&u.push(new A("size",t,t.caption,null));}}})),u}var N,k=function(){this.legendShape=null,this.slotLimits=new Map,this.dataLimit=-1;};!function(t){t.Em="em",t.Percentage="%",t.Centimeter="cm",t.Millimeter="mm",t.Inch="in",t.Pica="pc",t.Point="pt",t.Pixel="px";}(N||(N={}));var H,U,V=function(){function t(t,e){this.value=t,this.unit=e;}return t.fromObject=function(e){return new t(e.value,function(t){switch(t){case"em":return N.Em;case"%":return N.Percentage;case"cm":return N.Centimeter;case"mm":return N.Millimeter;case"in":return N.Inch;case"pc":return N.Pica;case"pt":return N.Point;case"px":return N.Pixel;default:throw new Error("Invalid length unit '"+t+"' specified")}}(e.unit))},t.prototype.toString=function(){return ""+this.value+this.unit},t}();!function(t){t.Normal="normal",t.Italic="italic";}(H||(H={})),function(t){t[t.Thin=100]="Thin",t[t.ExtraLight=200]="ExtraLight",t[t.Light=300]="Light",t[t.Normal=400]="Normal",t[t.Medium=500]="Medium",t[t.SemiBold=600]="SemiBold",t[t.Bold=700]="Bold",t[t.ExtraBold=800]="ExtraBold",t[t.Heavy=900]="Heavy";}(U||(U={}));var q=/\s+/g;function K(t){switch(t){case U.Normal:return "normal";case U.Bold:return "bold";case U.Thin:case U.ExtraLight:case U.Light:case U.Medium:case U.SemiBold:case U.ExtraBold:case U.Heavy:return t.toString();default:return ""}}function G(t){var e=[];if(t)for(var n=0,r=t.length;n<r;++n){var o=t[n],i=q.test(o);e.push(i?'"'+o+'"':o);}return e.join(", ")}var J=function(){function t(t,e,n,r){this.family=t,this.size=e,this.style=n,this.weight=r;}return t.fromObject=function(e){return new t(e.family||null,e.size?V.fromObject(e.size):null,e.style?function(t){switch(t){case"normal":return H.Normal;case"italic":return H.Italic;default:throw new Error("Invalid font style '"+t+"' specified")}}(e.style):null,void 0!==e.weight&&null!==e.weight?e.weight:null)},t.prototype.toString=function(){if(this.style!==H.Normal&&this.weight!==U.Normal||this.style===H.Normal&&this.weight===U.Normal){var t=[];return this.style===H.Normal?t.push("normal"):(this.style&&t.push(this.style),this.weight&&t.push(K(this.weight))),this.size&&t.push(this.size.toString()),this.family&&t.push(G(this.family)),t.join(" ")}return function(t){var e,n=[],r=G(t.family);return r.length>0&&n.push("font-family: "+r+";"),(r=t.size?t.size.toString():"").length>0&&n.push("font-size: "+r+";"),(r=(e=t.style)?e.toString():"").length>0&&n.push("font-style: "+r+";"),(r=K(t.weight)).length>0&&n.push("font-weight: "+r+";"),n.join(" ")}(this)},t}(),Q=function(){function t(t,e,n){var r=new Map;null!==t&&t.forEach((function(t,o){if("palette"===t.type){var i=t;switch(i.paletteType){case"cat":r.set(o,new x(i,e,n));break;case"cont":r.set(o,new E(i,e,n));}}})),this.source=t,this.palettes=r;}return t.prototype.get=function(t){return this._getValue(t,!1)},t.prototype.peek=function(t){return this._getValue(t,!0)},t.prototype._getValue=function(t,e){var n=this.source&&this.source.get(t);if(!n)return null;switch(n.type){case"string":case"number":case"boolean":case"enum":return e?n.peek:n.value;case"length":var r=e?n.peek:n.value;return r?V.fromObject(r):null;case"font":var o=e?n.peek:n.value;return o?J.fromObject(o):null;case"color":var i=e?n.peek:n.value;return i?C.fromObject(i):null;case"palette":return this.palettes.get(t)||null;default:return null}},t.prototype.isActive=function(t){var e=this.source&&this.source.get(t);return !!e&&e.active},t.prototype.setActive=function(t,e){var n=this.source&&this.source.get(t);n&&n.setActive(e);},t.prototype.isDirty=function(t){var e=this.source&&this.source.get(t);return !!e&&e.dirty},t}();var W=setTimeout;function X(t){return Boolean(t&&void 0!==t.length)}function Y(){}function Z(t){if(!(this instanceof Z))throw new TypeError("Promises must be constructed via new");if("function"!=typeof t)throw new TypeError("not a function");this._state=0,this._handled=!1,this._value=void 0,this._deferreds=[],ot(t,this);}function $(t,e){for(;3===t._state;)t=t._value;0!==t._state?(t._handled=!0,Z._immediateFn((function(){var n=1===t._state?e.onFulfilled:e.onRejected;if(null!==n){var r;try{r=n(t._value);}catch(t){return void et(e.promise,t)}tt(e.promise,r);}else(1===t._state?tt:et)(e.promise,t._value);}))):t._deferreds.push(e);}function tt(t,e){try{if(e===t)throw new TypeError("A promise cannot be resolved with itself.");if(e&&("object"==typeof e||"function"==typeof e)){var n=e.then;if(e instanceof Z)return t._state=3,t._value=e,void nt(t);if("function"==typeof n)return void ot((r=n,o=e,function(){r.apply(o,arguments);}),t)}t._state=1,t._value=e,nt(t);}catch(e){et(t,e);}var r,o;}function et(t,e){t._state=2,t._value=e,nt(t);}function nt(t){2===t._state&&0===t._deferreds.length&&Z._immediateFn((function(){t._handled||Z._unhandledRejectionFn(t._value);}));for(var e=0,n=t._deferreds.length;e<n;e++)$(t,t._deferreds[e]);t._deferreds=null;}function rt(t,e,n){this.onFulfilled="function"==typeof t?t:null,this.onRejected="function"==typeof e?e:null,this.promise=n;}function ot(t,e){var n=!1;try{t((function(t){n||(n=!0,tt(e,t));}),(function(t){n||(n=!0,et(e,t));}));}catch(t){if(n)return;n=!0,et(e,t);}}Z.prototype.catch=function(t){return this.then(null,t)},Z.prototype.then=function(t,e){var n=new this.constructor(Y);return $(this,new rt(t,e,n)),n},Z.prototype.finally=function(t){var e=this.constructor;return this.then((function(n){return e.resolve(t()).then((function(){return n}))}),(function(n){return e.resolve(t()).then((function(){return e.reject(n)}))}))},Z.all=function(t){return new Z((function(e,n){if(!X(t))return n(new TypeError("Promise.all accepts an array"));var r=Array.prototype.slice.call(t);if(0===r.length)return e([]);var o=r.length;function i(t,u){try{if(u&&("object"==typeof u||"function"==typeof u)){var s=u.then;if("function"==typeof s)return void s.call(u,(function(e){i(t,e);}),n)}r[t]=u,0==--o&&e(r);}catch(t){n(t);}}for(var u=0;u<r.length;u++)i(u,r[u]);}))},Z.resolve=function(t){return t&&"object"==typeof t&&t.constructor===Z?t:new Z((function(e){e(t);}))},Z.reject=function(t){return new Z((function(e,n){n(t);}))},Z.race=function(t){return new Z((function(e,n){if(!X(t))return n(new TypeError("Promise.race accepts an array"));for(var r=0,o=t.length;r<o;r++)Z.resolve(t[r]).then(e,n);}))},Z._immediateFn="function"==typeof setImmediate&&function(t){setImmediate(t);}||function(t){W(t,0);},Z._unhandledRejectionFn=function(t){"undefined"!=typeof console&&console&&console.warn("Possible Unhandled Promise Rejection:",t);};var it=function(t,e,n,r){this.data=t,this.decorations=e,this.properties=n,this.size=r;},ut=function(t,e,n,r,o){this.reason=t,this.data=e,this.node=n,this.props=r,this.locale=o;};var st=function(){function n(){this._data=null,this._elem=null,this._nls=null,this._locale="en-us",this._slotResolver=this.getSlotForPalette.bind(this),this.properties=new Q(null,null,this._slotResolver),this.meta=new k;}return n.prototype.init=function(t,e){var n=this,r=t.surface.appendChild(document.createElement("div"));r.setAttribute("style","left: 0; top: 0; width: 100%; height: 100%; position: absolute"),r.setAttribute("data-charttype","custom-viz"),this.properties=new Q(t.properties,t.dataContext,this._slotResolver),this._nls=t.nls,this._locale=t.locale,Z.resolve(this.create(r)).then((function(o){n._elem=o||r,t.properties.forEach((function(t,e){return n.updateProperty(e,t.value)})),e.complete();})).catch((function(t){e.fail(t);}));},n.prototype.destroy=function(){},n.prototype.getPropertyApi=function(){return null},n.prototype.setData=function(t){t&&t.dataSets&&t.dataSets[0]?this._data=b(t.dataSets[0]):this._data=null;},n.prototype.setProperty=function(t,e){this.updateProperty(t,this.properties.peek(t));},n.prototype.getBlockingRequests=function(){return null},n.prototype.render=function(t,e,n){if(!this._elem)return n.complete(null,null,null),null;if(!(e.data||e.decorations||e.properties||e.size))return n.complete(null,null,null),null;try{var r=this.update(new ut(function(t){return new it(t.data,t.decorations,t.properties,t.size)}(e),this._data,this._elem,this.properties,this._locale));Z.resolve(r).then((function(){return n.complete(null,null,null)})).catch(n.error);}catch(t){n.error(t);}return null},n.prototype.getEncodings=function(){return this._data?this.updateLegend(this._data):[]},n.prototype.getCapabilities=function(){var t=[];return this.meta.slotLimits.forEach((function(n,r){t.push(e.slotLimit(r,n));})),this.meta.dataLimit>=0&&t.push(e.dataLimit(this.meta.dataLimit)),t},n.prototype.getInteractivity=function(){return null},n.prototype.getVisCoordinate=function(t,e){return e},n.prototype.getRegionAtPoint=function(t,e){return null},n.prototype.getItemsAtPoint=function(t,e,n){if(!t||!t.hasOwnProperty("x")||!t.hasOwnProperty("y"))return null;var r=t,o=document.elementFromPoint(r.x,r.y),i=this.hitTest(o,r,e);return i&&i.source?[i.source]:[]},n.prototype.getItemsInPolygon=function(t,e){return []},n.prototype.getAxisItemsAtPoint=function(t,e,n){return []},n.prototype.getState=function(){return null},n.prototype.setState=function(t){},n.prototype.loadCss=function(t){var e=document.createElement("link");e.type="text/css",e.rel="stylesheet",e.href=this.toUrl(t),document.getElementsByTagName("head")[0].appendChild(e);},n.prototype.toUrl=function(e){return requirejs.toUrl(e)},n.prototype.update=function(t){},n.prototype.create=function(t){},n.prototype.updateProperty=function(t,e){},n.prototype.updateLegend=function(t){return z(t,this.properties,this.meta,this._slotResolver)},n.prototype.getSlotForPalette=function(t,e){return null},n.prototype.hitTest=function(t,e,n){var r=t&&t.__data__;return r&&r.source?r:null},n.prototype.nls=function(t){return this._nls&&this._nls.get(t)||""},n}();

  var COORDINATES = 0,
      VALUE = 1,
      COLOR = 2; // data column indices

  /**
   * Create function to return fill color for a line (group of DataPoints)
   * @param _colorCol Color slot
   * @param _props
   */

  function createGetFillColorFn(_colorCol, _props) {
    var palette = _props.get("line.colors");

    if (_colorCol.mapped) {
      return function (_dataPoints) {
        for (var i = 0; i < _dataPoints.length; ++i) {
          var dataPoint = _dataPoints[i];
          if (dataPoint) return palette.getFillColor(dataPoint);
        }

        return palette.getFillColor(null);
      };
    } else {
      var defaultColor = palette.getFillColor(null);
      return function (_d) {
        return defaultColor;
      };
    }
  }
  /**
   * Remove collided text by setting visibility
   * @param _elements Array of Text elements
   */


  function removeCollidedText(_elements) {
    var quadtree = d3.quadtree().x(function (d) {
      return d.x;
    }).y(function (d) {
      return d.y;
    });
    var widthRadius = 0;
    var heightRadius = 0;
    var rect;
    var hasCollided = false;

    function visit(_node, _x1, _y1, _x2, _y2) {
      if (hasCollided) return true;
      if (_node.data === rect) return false; // child node

      if (!_node.length) hasCollided = !(rect.right < _node.data.left || rect.left > _node.data.right || rect.bottom < _node.data.top || rect.top > _node.data.bottom);
      return !(rect.left < _x2 + widthRadius && rect.right > _x1 - widthRadius && rect.top < _y2 + heightRadius && rect.bottom > _y1 - heightRadius);
    }

    _elements.nodes().forEach(function (_element) {
      var collide = true;
      rect = _element.getBoundingClientRect();
      widthRadius = Math.max(widthRadius, rect.width);
      heightRadius = Math.max(heightRadius, rect.height);
      hasCollided = false;
      quadtree.visit(visit);

      if (!hasCollided) {
        quadtree.add(rect);
        collide = false;
      }

      _element.style.visibility = collide ? "hidden" : "visible";
    });
  }

  function applyFont(_selection, _font) {
    _selection.style("font-size", _font && _font.size ? _font.size.toString() : null).style("font-family", _font && _font.family ? _font.family.toString() : null).style("font-style", _font && _font.style ? _font.style.toString() : null).style("font-weight", _font && _font.weight ? _font.weight.toString() : null);
  }

  var _default = /*#__PURE__*/function (_RenderBase) {
    _inherits(_default, _RenderBase);

    var _super = _createSuper(_default);

    function _default() {
      _classCallCheck(this, _default);

      return _super.apply(this, arguments);
    }

    _createClass(_default, [{
      key: "create",
      // Create is called during initialization
      value: function create(_node) {
        // Create a svg node
        d3.select(_node).append("svg").attr("width", "100%").attr("height", "100%").append("g").attr("class", "chartContent"); // return the root node so it can be used in `update`.

        return _node;
      } // Update is called during new data, property change, resizing, etc.

    }, {
      key: "update",
      value: function update(_info) {
        var node = _info.node;

        if (!_info.data) {
          d3.select(".chartContent").selectAll("*").remove();
          return;
        }

        var hasSelection = _info.data.hasSelections;
        var cols = _info.data.cols;
        var rows = _info.data.rows; // data

        var coordinateGroupKeys = _info.data ? cols[COORDINATES].tuples.map(function (_s) {
          return _s.key;
        }) : [];
        var data = new Map();
        var dataKeys = [];

        var _loop = function _loop(i) {
          var row = rows[i];
          var catKey = row.tuple(COLOR) ? row.tuple(COLOR).key : "";
          var arr = void 0;

          if (!data.has(catKey)) {
            arr = new Array(coordinateGroupKeys.length).fill(null);
            data.set(catKey, arr);
            dataKeys.push(catKey);
          } else arr = data.get(catKey); // define at what place it should be put


          var coordinateKey = row.tuple(COORDINATES).key;
          var idx = coordinateGroupKeys.findIndex(function (_k) {
            return _k === coordinateKey;
          });
          arr[idx] = row;
        };

        for (var i = 0; i < rows.length; ++i) {
          _loop(i);
        } // props


        var props = _info.props;
        var lineWidth = props.get("line.width");
        var td = props.get("transition.duration");
        var transition = d3.transition().duration(td); // line color function

        var getFillColor = createGetFillColorFn(cols[COLOR], props); // measurements

        var clientHeight = node.clientHeight,
            clientWidth = node.clientWidth;
        var margin = {
          left: 10,
          right: 10,
          top: 10,
          bottom: 10
        };
        var content = {
          width: clientWidth - margin.left - margin.right,
          height: clientHeight - margin.top - margin.bottom
        }; // render containers

        var rootSelection = d3.select(node).select("svg").select(".chartContent");
        rootSelection.attr("transform", "translate(".concat(margin.left, ", ").concat(margin.top, ")"));
        var axes = coordinateGroupKeys.map(function (_key, _idx) {
          var r = v.filterRows(rows, COORDINATES, _key);
          var values = r.map(function (_r) {
            return _r.value(VALUE);
          });
          var domain = [Math.min.apply(Math, _toConsumableArray(values)), Math.max.apply(Math, _toConsumableArray(values))];
          var range = [content.height, 0];
          var scale = d3.scaleLinear().domain(domain).range(range).nice();
          var position = {
            x: content.width / (coordinateGroupKeys.length - 1) * _idx,
            y: 0
          };
          var axis;
          if (_idx === 0) axis = d3.axisLeft(scale);else axis = d3.axisRight(scale);
          axis.tickFormat(function (val) {
            return cols[VALUE].format(val.valueOf(), u.label);
          });
          return {
            key: _key,
            position: position,
            scale: scale,
            axis: axis,
            rows: r,
            label: cols[COORDINATES].tuples[_idx].caption
          };
        }); // draw axes

        var axisSelection = rootSelection.selectAll(".axis");
        axisSelection.data(axes, function (_axis) {
          return _axis.key;
        }).join(function (enter) {
          var g = enter.append("g").attr("transform", function (d) {
            return "translate(".concat(d.position.x, ", ").concat(d.position.y, ")");
          });
          g.append("text").attr("class", "axisTitle").text(function (d) {
            return d.label;
          }).attr("dy", "-1.5em").attr("fill", "currentColor");
          return g;
        }).attr("class", function (_, _i) {
          return "".concat(_i === axes.length - 1 ? "last" : _i === 0 ? "first" : "", " axis");
        }).attr("text-anchor", function (_, i) {
          return i === 0 ? "end" : "start";
        }).each(function (d) {
          var s = d3.select(this);
          s.call(d.axis);
        });

        this._applyAxisProperties(rootSelection.selectAll(".axis"), props); // calculate the "draw" area after all axis are drawed


        var lastAxis = rootSelection.select(".axis.last").node();
        var axisTitle = rootSelection.select(".axis .axisTitle").node();
        var firstAxis = rootSelection.select(".axis.first").node();
        var widthOfLastAxis = lastAxis ? lastAxis.getBBox().width : 0;
        var widthOfFirstAxis = firstAxis ? firstAxis.getBBox().width : 0;
        var heightOfLabels = props.get("axis.title.visible") && axisTitle ? axisTitle.getBBox().height + 10 : 0;
        var chartArea = {
          top: heightOfLabels,
          left: widthOfFirstAxis,
          height: Math.max(content.height - heightOfLabels, 0),
          width: Math.max(content.width - widthOfLastAxis - widthOfFirstAxis, 0)
        }; // update position of axes

        axes.forEach(function (_axis, _idx) {
          _axis.scale.range([chartArea.height, 0]);

          _axis.position = {
            x: chartArea.width / (axes.length - 1) * _idx + chartArea.left,
            y: chartArea.top
          };
        }); // update axes position so it renders in chartArea

        rootSelection.selectAll(".axis").transition(transition).attr("transform", function (d) {
          return "translate(".concat(d.position.x, ", ").concat(d.position.y, ")");
        }).each(function (d) {
          d3.select(this).call(d.axis);
        });
        var line = d3.line().x(function (_, idx) {
          return axes[idx].position.x;
        }).y(function (d, idx) {
          return axes[idx].scale(d.value(VALUE));
        }).defined(function (d) {
          return !!d;
        });
        var palette = props.get("line.colors"); // create groups

        var dataValues = dataKeys.map(function (e) {
          return data.get(e);
        });
        rootSelection.selectAll(".linesGroup").data(_info.data ? [1] : []).join("g").attr("class", "linesGroup").attr("transform", "translate(0, ".concat(axes[0].position.y, ")")).each(function () {
          var container = d3.select(this);
          container.selectAll(".line").data(dataValues) // bind the keys
          .join("path").attr("fill", "none").attr("class", "line").attr("stroke-width", function (ds) {
            return ds.some(function (d) {
              return d && (d.selected || d.highlighted);
            }) ? lineWidth + 1 : lineWidth;
          }).attr("stroke-opacity", function (ds) {
            return ds.some(function (d) {
              return d && (d.selected || d.highlighted);
            }) || !hasSelection ? 0.8 : 0.15;
          }).attr("stroke", function (ds) {
            return getFillColor(ds);
          }).transition(transition).attr("d", line);
        }); // Draw markers

        var markerRadius = props.get("marker.radius");
        rootSelection.select(".linesGroup").selectAll(".points").data(dataValues).join("g").attr("class", "points").each(function (ds) {
          var container = d3.select(this);
          container.selectAll(".point").data(ds).join("circle").attr("class", "point").transition(transition).attr("cx", function (_d, _i) {
            return axes[_i].position.x;
          }).attr("cy", function (_d, _i) {
            return _d ? axes[_i].scale(_d.value(VALUE)) : 0;
          }).attr("r", function (_d) {
            return _d ? _d.selected || _d.highlighted ? markerRadius + 1 : markerRadius : 0;
          }).style("fill", function (d) {
            return palette.getFillColor(d);
          });
        });
        d3.selectAll(".points").attr("display", props.get("marker.show") ? null : "none");
        removeCollidedText(rootSelection.selectAll("text"));
      }
    }, {
      key: "_applyAxisProperties",
      value: function _applyAxisProperties(_selector, _props) {
        //SVGGraphicsElement
        _selector.selectAll(".tick text").style("display", _props.get("axis.ticks.labels.visible") ? null : "none").attr("fill", _props.get("axis.ticks.labels.color")).call(applyFont, _props.get("axis.ticks.labels.font"));

        _selector.selectAll(".tick line").style("display", _props.get("axis.ticks.visible") ? null : "none").attr("stroke", _props.get("axis.ticks.color"));

        _selector.selectAll("path.domain")
        /*.style( "display", _props.get( "" ) ? null : "hidden" )*/
        .attr("stroke", _props.get("axis.line.color"));

        _selector.selectAll("text.axisTitle").style("display", _props.get("axis.title.visible") ? null : "none").attr("fill", _props.get("axis.title.color")).call(applyFont, _props.get("axis.title.font"));
      }
    }, {
      key: "updateProperty",
      value: function updateProperty(_name, _value) {
        switch (_name) {
          case "marker.show":
            this.properties.setActive("marker.radius", _value);
            break;
        }
      }
    }, {
      key: "getItemsAtPoint",
      value: function getItemsAtPoint(_vizCoord) {
        // Validate that the incoming vizCoord is a point with an x and y.
        if (!_vizCoord || !Object.prototype.hasOwnProperty.call(_vizCoord, "x") || !Object.prototype.hasOwnProperty.call(_vizCoord, "y")) return null; // unrecognized vizCoord
        // Cast to IRSPoint to use get x and y properties. Viewport is already an IRSPoint.

        var elem = document.elementFromPoint(_vizCoord.x, _vizCoord.y); // const data = this.hitTest( elem, coord, _viewport as Point );

        var datum = d3.select(elem).datum() || [];
        if (Array.isArray(datum)) return datum.filter(function (d) {
          return d && d.source;
        }).map(function (d) {
          return d.source;
        });
        if (datum instanceof m) return [datum.source];
        return null;
      }
    }]);

    return _default;
  }(st);

  return _default;

});
